swagger: "2.0"
info:
  description: "Description"
  version: "1.0.0"
  title: "MovieNode Challenge"
  termsOfService: "http://swagger.io/terms/"
  contact:
    email: "jfern.emp@gmail.com"
  license:
    name: "Apache 2.0"
    url: "http://www.apache.org/licenses/LICENSE-2.0.html"
host: "localhost:8080"
tags:
- name: "MovieNode Challenge"

schemes:
- "http"

paths:

          
  /movies:
    get:
      tags:
      - "movies"
      summary: "Finds a Movie by title or all data"
      description: "Simple request with the ''page'' number for pagination to get all movies OR add ''Title'' with an optiona year in the ''header'' find your movie"
      produces:
      - "application/json"
      parameters:
      - name: "Title"
        in: "query"
        description: "Title value needs to be considered for filter"
        required: false
        type: "string"
      - name: "year"
        in: "header"
        description: "optinal year for filter"
        required: false
        type: "string"
      - name: "page"
        in: "header"
        description: "start at 0"
        required: false
        type: "number"
        default: 0

      responses:
        "200":
          description: "successful operation"

        "400":
          description: "Bad request"
          
  /movies/replaceplot:
    post:
      tags:
        - "movies"
      summary: "find and replace on plot value"
      description: "To the string of the plot obtained, look for the word sent in the Body (find) and replace all its occurrences by the field sent in the body (replace)"
      consumes:
        - "application/x-www-form-urlencoded"
      parameters:
        - name: "Title"
          required: true
          type: "string"
          in: "formData"
        - name: "find"
          type: "string"
          in: "formData"
        - name: "replace"
          type: string
          in: "formData"
      responses:
        "200":
          description: "successful operation"

        "400":
          description: "Bad request"
          
  /movies/save:
    post:
      tags:
        - "movies"
      summary: "**BONUS** Insert a movie"
      description: "Since is probably to start with an empty db this could be useful to test the app"
      consumes:
        - "application/x-www-form-urlencoded"
      parameters:
        - name: "Title"
          required: true
          type: "string"
          in: "formData"
        - name: "Year"
          type: "string"
          in: "formData"
        - name: "Released"
          type: string
          in: "formData"
        - name: "Genre"
          required: true
          type: "string"
          in: "formData"
        - name: "Director"
          type: "string"
          in: "formData"
        - name: "Actors"
          type: string
          in: "formData"
        - name: "Plot"
          type: string
          in: "formData"
        - name: "Ratings"
          type: string
          in: "formData"

      responses:
        "200":
          description: "successful operation"

        "400":
          description: "Bad request"